#include <stdio.h>
#include <dos.h>
#include <string.h>
#include "emm.h"


static char far * emm_ptr;
static char yes_emm=0;

	// ஢ઠ ⠭ EMM

int	pascal emm_check
	( void )
{
void (_interrupt _far *EMM_driver_adr)(void);
char _far *EMM_driver_name;
char test_name[8];
int i;
EMM_driver_adr=_dos_getvect(EMM_N);
FP_SEG(EMM_driver_name)=FP_SEG(EMM_driver_adr);
FP_OFF(EMM_driver_name)=10;
for ( i=0; i<8; i++ ) test_name[i]=EMM_driver_name[i];
if ( strncmp(test_name,"EMMXXXX0",8) == 0 )
{
   yes_emm=1;
   emm_ptr=MK_FP(emm_frame(),0);
   return 0;
}
else { yes_emm=0; return -1; }
}

	// । ᥣ 

unsigned int	pascal emm_frame
	( void )
{
union REGS reg;
if ( yes_emm==0 ) return 0;
reg.x.ax=0x4100;
int86(EMM_N,&reg,&reg);
return reg.x.bx;
}

	// ᥣ EMS

int	pascal emm_total
	( void )
{
union REGS reg;
if ( yes_emm==0 ) return 0;
reg.x.ax=0x4200;
int86(EMM_N,&reg,&reg);
return reg.x.dx;
}

	//  EMS

int	pascal emm_free
	( void )
{
union REGS reg;
if ( yes_emm==0 ) return 0;
reg.x.ax=0x4200;
int86(EMM_N,&reg,&reg);
return reg.x.bx;
}

	// 뤥 EMS

int	pascal emm_new
	( int n_pages )
{
union REGS reg;
if ( yes_emm==0 ) return -1;
reg.x.ax=0x4300;
reg.x.bx=n_pages;
int86(EMM_N,&reg,&reg);
if ( reg.h.ah!=0 ) return -1;
return reg.x.dx;
}

	// 뤥 EMS

void	pascal emm_delete
	( int handle )
{
union REGS reg;
if ( yes_emm==0 ) return;
reg.x.ax=0x4500;
reg.x.dx=handle;
int86(EMM_N,&reg,&reg);
}

	// ⮡ࠧ  EMS

int	pascal emm_map
	( int handle, // 
	  int logical, //  ࠭  㫥
	  int physical //  ࠭ 㯠  0  3
	)
{
union REGS reg;
if ( yes_emm==0 ) return 0;
reg.h.ah=0x44;
reg.h.al=physical;
reg.x.bx=logical;
reg.x.dx=handle;
int86(EMM_N,&reg,&reg);
return reg.h.ah;
}

	// ࠭ ⥪

int	pascal emm_save
	( int handle )
{
union REGS reg;
if ( yes_emm==0 ) return 0;
reg.x.ax=0x4700;
reg.x.dx=handle;
int86(EMM_N,&reg,&reg);
return reg.x.ax;
}

	// ⠭ ⥪

int	pascal emm_restore
	( int handle )
{
union REGS reg;
if ( yes_emm==0 ) return 0;
reg.x.ax=0x4800;
reg.x.dx=handle;
int86(EMM_N,&reg,&reg);
return reg.x.ax;
}

	// ⠭ ⮡ࠦ  ᤢ  ࠭

char far * pascal emm_set
	( int handle, // 
	  long off // ᬥ饭
	)
{
char i;
long log;
char _huge * tmp;
if ( yes_emm==0 ) return 0;
emm_save(handle);
log=off;
log/=(SIZE_FRAME*1L);
for ( i=0; i<4; i++ )
	emm_map(handle,log+i,i);
log=off;
log%=(SIZE_FRAME*1L);
tmp=(char _huge *)(emm_ptr+log); tmp++; tmp--;
return (char far *)tmp;
}

/*
void	main
	( void )
{
int free, h_emm, frame;
char test1[]="  1";
char test2[]="  2";

if ( emm_check()==0 ) printf("EMM \n");
else { printf("EMM \n"); return; }
frame=emm_frame();
printf(" - %X\n",frame);
printf("ᥣ EMS \t- %d, %dK\n", emm_total(), emm_total()*16);
printf(" EMS \t- %d, %dK\n", emm_free(), emm_free()*16);
free=emm_free();
h_emm=emm_new(free);
if ( h_emm==-1 ) { printf(" \n"); return; }
else printf("१ࢨ஢\n");

emm=MK_FP(frame,0);
emm_map(h_emm,0,0);
_fstrcpy(emm,(char far *)test1);
emm_map(h_emm,1,0);
_fstrcpy(emm,(char far *)test2);

emm_map(h_emm,0,0);
_fstrcpy((char far *)test1,emm);
emm_map(h_emm,1,0);
_fstrcpy((char far *)test2,emm);
printf("%s,%s\n",test1,test2);

emm_delete(h_emm);
}
*/