#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <alloc.h>
#include <string.h>
#include "maglib.h"
#include "font.h"

extern word ptr_x, ptr_y, max_x, max_y;
extern void	pascal magHorizPattern
	( word x, word y, word w, word color, word pat );

vlProc fontProc=0;

	//
	// ⥭ 䮭  
	//
int	pascal magReadMFont
	( char * name, MagFont * mf )
{
FILE * fm;
int rc=OK, i;
long off_bits;

fm=fopen(name,"rb");
if ( fm==0 )
	return NO_FILE;
rc=magReadMFontFile(fm,mf);
fclose(fm);
return rc;
}

	//
	//   䮭
	//
void	pascal magResetMFont
	( MagFont * mf )
{
if ( mf->bits.ptr!=0 )
	farfree(mf->bits.ptr);
memset(mf,0,sizeof(MagFont));
}

	//
	// 뢮 ᨬ
	//
void	pascal magCharMFont
	( char ch, word color, MagFont * mf )
{
word i, c, j, n;
word w, h, x, y;
char far * ptr;
c=(byte)ch;
if ( mf->wt[c].width==0 ) c=32; // ஡
ptr=mf->wt[c].o.ptr;
x=ptr_x; y=ptr_y;
if ( x+w>max_x ) w=max_x-x;
if ( y+h>max_y ) h=max_y-y;
w=mf->wt[c].width;
n=w/8+(w%8?1:0);
h=mf->height;

for ( i=0; i<n; i++ )
{
  for ( j=0; j<h; j++ )
  {
	c=(byte)*(ptr+j);
	magHorizPattern(x,y+j,8,color,c);
  }
  x+=8;
  ptr+=h;
}
}

	//
	// 뢥 
	//
void	pascal magStrMFont
	( char * str, word color, MagFont * mf )
{
word i, len, ptr_old_x;
char ch;
ptr_old_x=ptr_x;
len=strlen(str);
for ( i=0; i<len; i++ )
{
	ch=str[i];
	if ( ptr_x>max_x ) break;
	magCharMFont(ch,color,mf);
	ptr_x+=mf->wt[(byte)ch].width+mf->space;
}
ptr_x=ptr_old_x;
}

	//
	//  ਭ 窨
	//
word	pascal magCalWidthStr
	( char * str, MagFont * mf )
{
word i, len, wid;
len=strlen(str);
wid=0;
for ( i=0; i<len; i++ )
	wid+=mf->wt[(byte)str[i]].width+mf->space;
return wid;
}

	//
	// 뢮 窨 ⥪
	//
void	magSetStrMFont
	( word x, word y, word w,
	  byte alig, // ࠢ
	  byte shadow, // ᪮쪮 ᬥ ⥭
	  long del, // প  뢮 ᨬ
	  word color, word col_sha,
	  char * str, MagFont * mf )
{
word i, len, ptr_old_x, ptr_old_y, size, sp;
char ch;

if ( w==0 ) return;
ptr_old_x=ptr_x;
ptr_old_y=ptr_y;
magXY(x,y);
sp=mf->space;
len=strlen(str);
if ( len==0 ) 
	return;
size=magCalWidthStr(str,mf);
while ( 1 )
{
	if ( size<=w ) break;
	len--;
	size-=mf->wt[(byte)str[len-1]].width+mf->space;
}
switch ( alig )
{
case ALIG_LEFT: break;
case ALIG_RIGHT: ptr_x+=w-size; break;
case ALIG_CENT: ptr_x+=(w-size)/2; break;
case ALIG_FULL: sp+=(w-size)/len; break;
}

for ( i=0; i<len; i++ )
{
	if ( kbhit()!=0 )
		del=0;
	ch=str[i];
	if ( ptr_x>max_x ) break;
	if ( shadow!=0 )
	 { ptr_x+=shadow; ptr_y+=shadow;
	   magCharMFont(ch,col_sha,mf);
	   ptr_x-=shadow; ptr_y-=shadow;
	 }
	magCharMFont(ch,color,mf);
	ptr_x+=mf->wt[(byte)ch].width+mf->space;
	if ( del!=0 )
	{
		if ( fontProc!=0 ) fontProc(del);
		else delay(del);
	}
}
ptr_x=ptr_old_x;
ptr_y=ptr_old_y;
}
	//
	// ⥭ 䮭    䠩
	//
int	pascal magReadMFontFile
	( FILE * fm, MagFont * mf )
{
int rc=OK, i;
long off_bits, beg;

if ( fm==0 )
	return NO_FILE;
beg=ftell(fm);
fread(mf,sizeof(MagFont),1,fm);
off_bits=mf->bits.off;
mf->bits.ptr=0;
if ( ferror(fm) )
{
	rc=NO_READ;
	goto Fin;
}
if ( mf->id!=ID_FONT )
{
	rc=NO_FILE;
	goto Fin;
}
mf->bits.ptr=(char far * )farmalloc(mf->len);
if ( mf->bits.ptr==0 ) { rc=NO_MEMORY; goto Fin; }
fseek(fm,off_bits+beg,SEEK_SET);
//fread(mf->bits.ptr,mf->len,1,fm);
unzip_buf(fm,mf->len,mf->bits.ptr);

for ( i=0; i<256; i++ )
  mf->wt[i].o.ptr=(char far*)( mf->bits.ptr+mf->wt[i].o.off);
mf->space=0;

Fin:
if ( rc!=OK )
	if ( mf->bits.ptr!=0 ) farfree(mf->bits.ptr);
return rc;
}
