#ifndef __FONT_H
#define __FONT_H

#ifndef __MAGTYPE_H
#include "magtype.h"
#endif

#define ID_FONT 'MF'

#define ALIG_LEFT	0
#define ALIG_RIGHT	1
#define ALIG_CENT	2
#define ALIG_FULL	3

typedef union {
	char far * ptr;
	long	off;
} Offset;

typedef struct {
	word	width;		// ਭ ᨬ
	Offset	o;		// ᬥ饭 ⭮⥫쭮 砫 
} WidthTable;

typedef struct {
	word	id;		// 䨪
	byte	ver;		//  - 0
	word	width;		// ਭ !=0 - ਩
	word	height;		// 
	char	face[21];	//  
	long	len;		//  
	WidthTable wt[256];	// ⠡ ਭ
	Offset	bits;		// 㪠⥫  
	word	space;		// ய  ᨬ
	word	res1;
	long	res2;
} MagFont;

#ifdef __cplusplus
extern "C" {
#endif
	//
	// ⥭ 䮭  
	//
int	pascal magReadMFont
	( char * name, MagFont * mf );
	//
	// ⥭ 䮭    䠩
	//
int	pascal magReadMFontFile
	( FILE * fm, MagFont * mf );
	//
	//   䮭
	//
void	pascal magResetMFont
	( MagFont * mf );
	//
	// 뢮 ᨬ
	//
void	pascal magCharMFont
	( char ch, word color, MagFont * mf );
	//
	// 뢥 
	//
void	pascal magStrMFont
	( char * str, word color, MagFont * mf );
	//
	//  ਭ 窨
	//
word	pascal magCalWidthStr
	( char * str, MagFont * mf );
	//
	// 뢮 窨 ⥪
	//
void	magSetStrMFont
	( word x, word y, word w,
	  byte alig, // ࠢ
	  byte shadow, // ᪮쪮 ᬥ ⥭
	  long delay, // প  뢮 ᨬ
	  word color, word col_sha,
	  char * str, MagFont * mf );

#ifdef __cplusplus
}
#endif

#endif
