#ifndef __KEY_H
#define __KEY_H

#ifndef __MAGTYPE_H
#include "magtype.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define    kbRightShift  0x0001
#define    kbLeftShift   0x0002
#define    kbScrollState 0x0010
#define    kbCapsState   0x0040
#define    kbF1        0x3b00
#define    kbF2        0x3c00
#define    kbF3        0x3d00
#define    kbF4        0x3e00
#define    kbF5        0x3f00
#define    kbF6        0x4000
#define    kbF7        0x4100
#define    kbF8        0x4200
#define    kbF9        0x4300
#define    kbF10       0x4400
#define    kbUp        0x4800
#define    kbLeft      0x4b00
#define    kbRight     0x4d00
#define    kbDown      0x5000
#define    kbPgUp      0x4900
#define    kbPgDn      0x5100
#define    kbEsc       0x011b
#define    kbEnter     0x1c0d
#define    kbSpace     0x3920
#define    kbCtrlLeft  0x7300
#define    kbCtrlRight 0x7400
#define    kbAltX      0x2d00
#define    kbHome      0x4700
#define    kbEnd       0x4f00
#define    kbBack      0x0e08
#define    kbIns       0x5200
#define    kbDel       0x5300
#define    kbShiftTab  0x0f00
#define    kbTab       0x0f09

//  ᮡ⨩
#define    evNOT       0	//  ᮡ
#define    evKey       1        //  
#define    evFlags     2        //  ﭨ 㦥 

    //
    //   প
    //
void pascal rate_delay ( byte, byte );
    //
    // ⥭      
    //
word pascal read_key ( void );
    //
    //   
    //
byte pascal write_key ( word );
    //
    // ஢ઠ  ⨥ 0 -   ; 1 -  ; 2 - ࠢ. 
    //
byte pascal ready_key ( void );
    //
    // ⥭ 䫠
    //
word pascal read_flags ( void );
    //
    // ⪠  
    //
void pascal clear_buffer( void );

byte pascal is_key ( word k );

word	pascal wait_key
	( long time_wait );

#ifdef __cplusplus
}
#endif

#endif
