#if     !defined(__LIB_H)
#define __LIB_H

#include <stdio.h>
#include "list.h"

#define LIB_NAME 16
#define LIB_IDEN "LIB1"

typedef struct {
	char name[LIB_NAME];
	long offset;
	long len;
} RecLib;

typedef struct {
	List lf;
	FILE * fr;
	char * buf;
} Lib;

#ifdef __cplusplus
extern "C" {
#endif

Lib * pascal libNew
	( void );

void pascal libFree
	( Lib * l );

int pascal libCreate
	( Lib * l, char * name, word len_buf );

int pascal libOpen
	( Lib * l, char * name, word len_buf );

int pascal libClose
	( Lib * l );

int pascal libFind
	( Lib * l, char * name );

int pascal libSeek
	( Lib * l, char * name );

int pascal libAdd
	( Lib * l, char * name );

int pascal libSetLen
	( Lib * l, char * name, long len );

int pascal libDelete
	( Lib * l, char * name );

int pascal libAddBuf
	( Lib * l, char * name, char * buf, word len );

long pascal libReadBuf
	( Lib * l, char * name, char * buf );

char * pascal libSeekNumber
	( Lib * l, word n );

word pascal libCount
	( Lib * l );

#ifdef __cplusplus
}
#endif

#endif
