#if     !defined(__LIST_H)
#define __LIST_H

//
//  ᨬ .. 1992
//  㭪樨  ࠡ  ᯨ᪠
//

#include <stdio.h>

#ifndef NULL
#if defined(__TINY__) || defined(__SMALL__) || defined(__MEDIUM__)
#define NULL  0
#else
#define NULL  0L
#endif
#endif

#ifndef __MAGTYPE_H
#include "magtype.h"
#endif

// ᨬ쭮 ᫮ ⮢  ᯨ᪥
#define MaxSizeList  16380

typedef struct { // ᮪ ⮢
	int count;	// ⥪騥 ⢮ ⮢
	int limit;	// ⠭ ࠧ ᯨ᪠
	int delta;	// 饭
	int size_item;	// ࠧ 
	void **items;   // ᯨ᮪
} List;

#ifdef __cplusplus
extern "C" {
#endif

int   pascal InsertItem(  // ⠢   
		List * l,
		int index,
		void *item
		);

int   pascal AddItem( // ⠢    ᯨ᪠
		List * l,
		void *item
		);

int   pascal ChangeItemN(  //    
		List * l,
		int index,
		void *item
		);

int   pascal FindItem( // 頥  
		List * l,
		void *item
		);

int   pascal RemoveItemN( // ࠥ      ࠧ ᯨ᪠
		List * l,
		int index
		);

int   pascal RemoveItem( // ࠥ 㪠⥫  
		List * l,
		void *item
		);

void  pascal RemoveList( // ࠥ ᯨ᮪
		List * l
		);

void *  pascal Item( // 㪠⥫    
		List * l,
		int index
		);

int	pascal SearchIndex( //    
		List * l,
		void * item,
		int (*fcmp)(const void*, const void*)
		);

int   pascal FreeItemN( // 㤠   ᢮ 
		List * l,
		int index
		);

int   pascal FreeItem( // 㤠 
		List * l,
		void *item
		);

void  pascal FreeList( // 㤠 ᯨ᪠
		List * l
		);

void  pascal PackList( //   㫥 㪠⥫
		List * l
		);

int   pascal SetList( // ᮧ ᯨ᮪
		List * l,
		int lim 	// ࠧ ᯨ᪠
		);

int pascal ReadList ( //   
		List * l,	// ᯨ᮪
		FILE * f	// 㪠⥫  䠩
		);

int pascal WriteList ( //   
		List * l,	// ᯨ᮪
		FILE * f	// 㪠⥫  䠩
		);

#ifdef __cplusplus
}
#endif

#endif
