#pragma inline
#include <dos.h>
#include <mem.h>
#include <alloc.h>
#include "maglib.h"

char copyright[]="Copyright (c) 1994-5 v1 MAGLIB ᨬ .. VESAx256";

VESAinfo vi;
VESAmodeInfo vmi;
struct REGPACK reg;
char bufPals[800];
char _bufPlanes[2000];

void	pascal magSetWin ( word x, word y );
void	pascal magHorizLine ( word x, word y, word w, word color);

//  
vvProc fonProc=0;

word ptr_x=0, ptr_y=0, max_x=0, max_y=0, max_color=0;
word ptr_color=0, ptr_pattern=0, ptr_oper=0, gran, size_win, gran64, gran_shift;
char far * vid_buf;
word bytes_line, ptr_win;
char far * vid_ptr;
byte comp_ptr=0, opt=0;
word seg_w, off_w;
long size_win_bytes;
long * vals;

	//
	//  
	//

char	pascal type_comp
	( void ) // 0-86, 1-286, 2-386
{
asm	sub	bx, bx;
asm	push	sp;
asm	pop	ax;
asm	cmp	ax, sp;
asm	jne	M1;
asm	mov	ax, 7000h;
asm	push	ax;
asm	popf;
asm	pushf;
asm	pop	ax;
asm	mov	bl, 1;
asm	and	ax, 7000h;
asm	jz	M1;
asm	inc	bx;
M1:
return _BL;
}


	//
	// ⠭ ᪮ ०  
	//

int	pascal magSetGameMode
	( word r )
{
int rc, i;
comp_ptr=type_comp();
if ( comp_ptr<2 ) return NO_386;
// ஢ઠ VESA
reg.r_ax=0x4f00;
reg.r_es=FP_SEG(&vi);
reg.r_di=FP_OFF(&vi);
intr(0x10,&reg);
if ( reg.r_ax != 0x4f ) return ERR_NO_VESA;
// ⠭ ०
reg.r_ax=0x4f02;
reg.r_bx=r;
intr(0x10,&reg);
if ( reg.r_ax != 0x4f ) return ERR_NO_REG;
// ᭮ ଠ  ०
reg.r_ax=0x4f01;
reg.r_cx=reg.r_bx;
reg.r_es=FP_SEG(&vmi);
reg.r_di=FP_OFF(&vmi);
intr(0x10,&reg);
if ( !((reg.r_ax == 0x4f) && (vmi.sup) && (vmi.a_exists)) ) return ERR_NO_REG;
// ७ ६
max_color=1<<vmi.bit_per_pixels; gran=vmi.gran_k; size_win=vmi.size_k;
max_x=vmi.width-1; max_y=vmi.height-1; bytes_line=vmi.bytes_line;
vid_buf=MK_FP(vmi.seg_a,0); ptr_win=0xffff;

gran64=size_win/gran;
if ( size_win==64 && (gran%2==0) )
{
	gran_shift=0;
	i=gran64;
	while ( i!=1 )
	{
		gran_shift++;
		i/=2;
	}
	opt=1;
}
else opt=0;

size_win_bytes=size_win;
size_win_bytes*=1024l;
vals=(long*)malloc(max_y*4);
if ( vals==0 ) return -1;
for ( i=0; i<max_y; i++ )
{
	vals[i]=bytes_line;
	vals[i]*=i;
}
magGetPals();
return OK;
}


	//
	// ⠭ ⥪⮢ ०
	//

void	pascal magSetDosMode
	( void )
{
reg.r_ax=0x3;
magWaitRetr();
intr(0x10,&reg);
free(vals);
}


	//
	// ⨥ 
	//

void	pascal magGetPals
	( void )
{
reg.r_ax=0x1017;
reg.r_bx=0;
reg.r_cx=0x100;
reg.r_es=FP_SEG(bufPals);
reg.r_dx=FP_OFF(bufPals);
magWaitRetr();
intr(0x10,&reg);
}


	//
	// ⠭ 
	//

void	pascal magSetPals
	( void )
{
reg.r_ax=0x1012;
reg.r_bx=0;
reg.r_cx=0x100;
reg.r_es=FP_SEG(bufPals);
reg.r_dx=FP_OFF(bufPals);
magWaitRetr();
intr(0x10,&reg);
}

void	pascal setDAC
	( byte n, byte r, byte g, byte b )
{
asm	mov	dx, 03C8h;
asm	mov	al, n;
asm	cli;
asm	out	dx, al;
asm	inc	dx;
asm	mov	al, r;
asm	out	dx, al;
asm	mov	al, g;
asm	out	dx, al;
asm	mov	al, b;
asm	out	dx, al;
asm	sti;
}


	//
	// ⠭ 
	//

void	pascal magSetDAC
	( void )
{
char far * t;
t=(char far * )bufPals;
//  ᨭ஭樨
asm	mov	dx,	0x3DA;
wait_not:
asm	in	al,	dx;
asm	and	al,	0x8;
asm	jnz	wait_not;
wait:
asm	in	al,	dx;
asm	and	al,	0x8;
asm	jz	wait;

// ࠭ ॣ  ⥪
asm	push	es;
// 㫨 䫠 ࠢ DF - 뫪   ᮢ
asm	cld;
// 㧨 筨  DS:SI
asm	lds	si,	t;

asm	mov	dx,	0x3C8;
asm	sub	al,	al;
asm	out	dx,	al;

asm	mov	cx,	768;
asm	mov	dx,	0x3C9;
asm	rep	outsb;
asm	pop	es;
}

	//
	//  室 
	//

void	pascal magWaitRetr
	( void )
{
asm	mov	dx,	0x3DA;
wait_not:
asm	in	al,	dx;
asm	and	al,	0x8;
asm	jnz	wait_not;
wait:
asm	in	al,	dx;
asm	and	al,	0x8;
asm	jz	wait;
}


void	pascal magSetWin
	( word x, word y )
{
word start;
long l;
l=vals[y]; l+=x;
seg_w=l/size_win_bytes;
off_w=l%size_win_bytes;
if ( seg_w!=ptr_win )
{
if ( opt==1 )
	start=seg_w<<gran_shift;
else
	start=seg_w*gran64;
asm	mov	dx, start;
asm	mov	ax, 04f05H;
asm	mov	bx, 0;
asm	push	bp;
asm	push	dx;
asm	push	ax;
asm	int	10h;
asm	mov	bx, 0100h;
asm	pop	ax;
asm	pop	dx;
asm	int	10h;
asm	pop	bp;
ptr_win=seg_w;
}
vid_ptr=vid_buf+off_w;
}
