#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include <string.h>
#include <mem.h>
#include <io.h>
#include <alloc.h>
#include <dir.h>
#include "maglib.h"
#include "gif.h"

pcxHeader ph;
char buf[800];
char far * image=0;
char drive[MAXDRIVE];
char dir[MAXDIR];
char file[MAXFILE];
char ext[MAXEXT];

gifHeader gh;
gifImageHeader gih;

void	exit_g
	( void )
{
if ( image!=0 ) farfree(image);
magGifDelMem();
}

void	viewPcx
	( char * n )
{
word w,h, i;
int hPcx,rc;
long len_image;

hPcx=magReadHeaderPcx(n,&ph,buf);
if ( hPcx<0 ) goto FIN;
w=(ph.xh-ph.xl+1);
h=(ph.yh-ph.yl+1);
setmem(bufPals,LEN_PAL_256,0);
magSetPals();
len_image=(long)w;
len_image*=(long)h;
rc=magShowPcx(hPcx,&ph);
if ( rc<0 ) goto FIN;
magOnOff(SCREEN_ON,buf);
getch();
magOnOff(SCREEN_OFF,buf);

FIN:
_close(hPcx);
}

void	viewGif
	( char * n )
{
int hG, rc;
hG=magReadHeaderGif(n,&gh,&gih,buf);
if ( hG<0 ) goto GFIN;
image=(char far *) farmalloc((long)gih.width*(long)gih.height);
if ( image==0 ) goto GFIN;
rc=magReadGif(hG,&gih,image);
if ( rc<0 ) goto GFIN;
setmem(bufPals,LEN_PAL_256,0);
magSetPals();
magXY(0,0);
magSetImage(gih.width,gih.height,image);
magOnOff(SCREEN_ON,buf);
getch();
magOnOff(SCREEN_OFF,buf);
GFIN:
_close(hG);
magGifDelMem();
}


void	main
	( int argc, char * argv[] )
{
word i;

atexit(exit_g);
printf("  PCX, GIF   640x480x256 VESA\n");
printf("ᨬ .. 1994 v1. FREEWARE\n");
if ( argc==1 ) { printf("GVIEW.EXE \" \"\n"); return; }
i=MODE_640_480_256;
switch ( magSetGameMode(i) )
{
case OK: break; //{ printf("VESA ! 256\n"); getch(); break;}
case ERR_NO_VESA: { printf("NO_VESA !\n"); return; }
case ERR_NO_REG: { printf("NO 256\n"); return; }
}
fnsplit(argv[1],drive,dir,file,ext);
if ( stricmp(ext,".gif")==0 ) viewGif(argv[1]);
if ( stricmp(ext,".pcx")==0 ) viewPcx(argv[1]);
magSetDosMode();
}
