#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <alloc.h>
#include <stdarg.h>
#include "maglib.h"

char * bufSysFNT=0;
word  w_fnt=8, h_fnt;
extern word ptr_x, ptr_y, max_x, max_y, max_color;
extern void	pascal magHorizPattern
	( word x, word y, word w, word color, word pat );

int	pascal magReadFont ( char * FileFont )
{
int hFNT, err;
long lenFNT;
hFNT=_open(FileFont,O_RDONLY);
if ( hFNT == -1 ) return NO_FILE;
lenFNT=filelength(hFNT);
if ( lenFNT == -1L ) return NO_FILE;
if ( bufSysFNT ) free(bufSysFNT);
bufSysFNT=(char*)farmalloc(lenFNT) ;
if ( !bufSysFNT ) { _close(hFNT); return NO_MEMORY; }
err=_read(hFNT,bufSysFNT,(word)lenFNT);
_close(hFNT);
if ( err == -1 )
{
  free(bufSysFNT) ;
  bufSysFNT=0;
  return NO_READ;
}
h_fnt=lenFNT/256;
return lenFNT;
}


void	pascal magResetFont
	( void )
{
if ( bufSysFNT ) free( bufSysFNT );
}

word	pascal magWidthFont
	( void )
{ return w_fnt; }

word	pascal magHeightFont
	( void )
{ return h_fnt; }

void	pascal magChar
	( char ch, word color )
{
word i, c;
c=(byte)ch;
for ( i=0; i<h_fnt; i++ )
	magHorizPattern(ptr_x,ptr_y+i,w_fnt,color,bufSysFNT[c*h_fnt+i]);
}

void	pascal magStr
	( char * str, word color )
{
word i, len, ptr_old_x;
ptr_old_x=ptr_x;
len=strlen(str);
for ( i=0; i<len; i++ )
{
	if ( ptr_x>max_x ) break;
	magChar(str[i],color);
	ptr_x+=w_fnt;
}
ptr_x=ptr_old_x;
}

							///////////
void pascal	drawRec
	( word x, word y, word w, word h, word fon )
{
magXY(x*w_fnt,y*h_fnt);
magRect( w*w_fnt, h*h_fnt, fon );
}
							///////////
void pascal	drawText
	( word x, word y, word color, char * s )
{
magXY(x*w_fnt,y*h_fnt);
magStr(s,color);
}
							///////////
void pascal	gputs
	( word x, word y, word attr, char * s )
{
word len=strlen ( s );
if ( !len ) return;
drawRec  ( x, y, len, 1, (word)((attr&0xf0)>>4) ) ;
drawText ( x, y, (word)(attr&0xf), s ) ;
}
							///////////
void pascal	gputc
	( word x, word y, word attr, char c )
{
char s[2];s[0]=c;s[1]=0;
gputs ( x, y, attr, s );
}
							///////////
void	gprintf
	( word x, word y, word attr, char *fmt, ... )
{
va_list argptr;
char str[83];
va_start(argptr,fmt);
vsprintf(str,fmt,argptr);
gputs ( x, y, attr, str );
va_end( argptr );
}
