#pragma inline
#include <dos.h>
#include <mem.h>
#include <alloc.h>
#include "maglib.h"

extern word ptr_x, ptr_y, max_x, max_y, max_color;
static char bufPl[700];

	//
	// ନ஢  ࠩ
	//
int	pascal magNewSpr
	( Sprite * s, word w, word h, word fonColor, char far * sp )
{
long len;
len=(long)w;
len*=(long)h;
s->mem=s->set=s->shadow=0;
if ( len>=0xffffL ) return NO_MEMORY;
s->fon=(char far *)malloc((word)len);
s->fon1=(char far *)malloc((word)len);
s->buf=(char far *)malloc((word)len);
if ( s->fon==0 || s->fon1==0 || s->buf==0 ) return NO_MEMORY;
s->w=w; s->h=h; s->fonColor=fonColor; s->sp=sp; s->mem=1;
return OK;
}

	// ⠭ ⥭  ࠩ
void	pascal magSprShadow
	( Sprite * s, char * pallete, word colorShadow, int r, int g, int b, byte filtr )
{
if ( s->fon==0 || s->buf==0 ) return;
s->tab_shadow=(char far *)malloc(LEN_PAL_256);
if ( s->tab_shadow==0 ) return;
magShiftPal(pallete,s->tab_shadow,r,g,b,filtr);
s->shadowColor=colorShadow;
s->shadow=1;
}

	//
	//  ࠩ
	//
void	pascal magDelSpr
	( Sprite * s )
{
s->mem=s->set=s->shadow=0;
free(s->buf);
free(s->fon);
free(s->fon1);
free(s->tab_shadow);
}

	//
	// 뢮 ࠩ
	//
void	pascal magSetSpr
	( Sprite * s, byte lr ) // lr=0 - ᫥ ࠢ
{
register word i, j;
byte coor,c,shadow;
word len, old_x, old_y;
char far *b, far * sp;
//char _huge * tmp;
if ( s->mem==0 ) return;

old_x=ptr_x; old_y=ptr_y;
c=s->fonColor;
if ( ptr_x==s->x && ptr_y==s->y ) coor=1;
else coor=0;
if ( s->set==1 && coor==0 )
   {
	magXY(s->x,s->y);
	magQuickImage(s->w,s->h,s->fon);
	s->set=0;
   }

ptr_x=old_x; ptr_y=old_y;

if ( s->set==0 || coor==0 )
	magGetImage(s->w,s->h,s->fon);

// 뢮  buf fon
len=s->w*s->h; shadow=s->shadowColor;
copyByte(s->fon,s->buf,len);
if ( lr==0 )
{
	if ( s->shadow==1 )
		magSprImageShadow
		(s->w,s->h,s->sp,s->buf,c,s->tab_shadow,shadow);
	else
		magSprImage(s->w,s->h,s->sp,s->buf,c);
}
else
{
	b=hugeAddr(s->buf);
	sp=hugeAddr(s->sp);
	if ( s->shadow==1 )
	{
		for ( i=0; i<s->h; i++ )
   		{
   			sp+=s->w;
   			for ( j=0; j<s->w; j++ )
      			{
	 			sp--;
	 			if ( (*sp)!=c ) *b=*sp;
				if ( (*sp)==shadow )
					*b=s->tab_shadow[(byte)*b];
	 			b++;
      			}
   			sp+=s->w;
   		}
	}
	else
	{
		for ( i=0; i<s->h; i++ )
   		{
   			sp+=s->w;
   			for ( j=0; j<s->w; j++ )
      			{
	 			sp--;
	 			if ( (*sp)!=c ) *b=*sp;
	 			b++;
      			}
   			sp+=s->w;
   		}
	}
}
// 뢮  ࠭
magQuickImage(s->w,s->h,s->buf);
s->set=1; s->x=ptr_x; s->y=ptr_y;
}

	//
	//  ࠩ  ࠭
	//
void	pascal magRemSpr
	( Sprite * s )
{
word old_x, old_y;
if ( s->set==0 ) return;
old_x=ptr_x; old_y=ptr_y;
magXY(s->x,s->y);
magQuickImage(s->w,s->h,s->fon);
s->set=0;
ptr_x=old_x; ptr_y=old_y;
}

	//
	//  ᫥⥫쭮 ࠩ⮢
	//
void	pascal magAnimate
	( Sprite * s, char far * f[], word ptr_f, byte lr )
{
magRemSpr(s);
s->sp=f[ptr_f];
magSetSpr(s,lr);
}

	//
	// ⠭ 
	//
void	pascal magRestoreSpr
	( Sprite * s, word x, word y, word w, word h, byte lr )
{
word ex, ey, exm, eym;
byte part_x=1, part_y=1;
word x1, y1, w1, h1;
word old_x, old_y;

ex=x+w-1; ey=y+h-1; exm=s->x+s->w-1; eym=s->y+s->h-1;
if ( ex<s->x || x>exm ) return;
if ( ey<s->y || y>eym ) return;
if ( x<s->x && ex>exm ) part_x=0;
if ( y<s->y && ey>eym ) part_y=0;
old_x=ptr_x; old_y=ptr_y;
if ( part_x==0 && part_y==0 )
{
// 
   s->set=0;
   magXY(s->x,s->y);
   magSetSpr(s,lr);
   ptr_x=old_x; ptr_y=old_y;
   return;
}
// 筮
x1=s->x; y1=s->y; w1=s->w; h1=s->h;
if ( part_x==1 )
{
if ( x>=s->x && x<=exm ) { x1=x; w1-=x-s->x; }
if ( ex>=s->x && ex<=exm ) w1-=exm-ex;
}
if ( part_y==1 )
{
if ( y>=s->y && y<=eym ) { y1=y; h1-=y-s->y; }
if ( ey>=s->y && ey<=eym ) h1-=eym-ey;
}
magXY(x1,y1);
magGetImagePart(s->w,s->h,s->fon,x1-s->x,y1-s->y,w1,h1);
s->set=1;
magXY(s->x,s->y);
magSetSpr(s,lr);
ptr_x=old_x; ptr_y=old_y;
}

	// ஢    old,   new,
	// ᫨ ࠦ im  ᮢ  new
int	pascal CopyCmp
	( char far * im, char far * old, char far * new, unsigned int len )
{
int i;

if ( len == 0 ) return 0;
im=hugeAddr(im);
old=hugeAddr(old);
new=hugeAddr(new);
// ࠭ ॣ  ⥪
asm	push	ds;
asm	push	es;
// 㫨 䫠 ࠢ DF - 뫪   ᮢ
asm	cld;
// 㧨 筨  DS:SI,  ਥ  ES:DI
asm	les	di,	im;
asm	lds	si,	new;
// 稪 横
asm	mov	cx,	len;
asm	mov	dx,	0; // 稪 old

Loop:
asm	lodsb;	// ds:[si]
asm	mov	ah,	es:[di];
asm	cmp	al,	ah;
asm	je	Skip;
// ஢   䮭  
asm	push	ds;
asm	lds	bx,	old;
asm	add	bx,	dx;
asm	mov	ds:[bx], al;
asm	mov	word ptr i,	1;
asm	pop	ds;

Skip:
asm	inc	di;
asm	inc	dx;
asm	dec	cx;
asm	jnz	Loop;

// ⠭ ॣ
asm	pop	es;
asm	pop	ds;

return i;
}

	//
	// ⮬᪮ ⠭ ࠩ
	//
void	pascal magBurnSpr
	( Sprite * s, byte lr )
{
word len;
word old_x, old_y;

old_x=ptr_x; old_y=ptr_y;
magXY(s->x,s->y);
magGetImage(s->w,s->h,s->fon1);
len=s->h*s->w;
if ( CopyCmp(s->buf,s->fon,s->fon1,len)==1 )
{
   magXY(s->x,s->y);
   magSetSpr(s,lr);
}
ptr_x=old_x; ptr_y=old_y;
}

	//
	//  ࠦ ࠩ  㣮 ࠦ
	//

byte pascal magSetImageSpr
	( Sprite * s, byte lr,
	  char far * im, word x, word y, word w, word h )
{
word ex, ey, exm, eym;
byte part_x=1, part_y=1;
word x1, y1, w1, h1;

ex=x+w-1; ey=y+h-1; exm=s->x+s->w-1; eym=s->y+s->h-1;
if ( ex<s->x || x>exm ) return 0;
if ( ey<s->y || y>eym ) return 0;
if ( x<s->x && ex>exm ) part_x=0;
if ( y<s->y && ey>eym ) part_y=0;
x1=s->x; y1=s->y; w1=s->w; h1=s->h;
if ( part_x==1 )
{
if ( x>=s->x && x<=exm ) { x1=x; w1-=x-s->x; }
if ( ex>=s->x && ex<=exm ) w1-=exm-ex;
}
if ( part_y==1 )
{
if ( y>=s->y && y<=eym ) { y1=y; h1-=y-s->y; }
if ( ey>=s->y && ey<=eym ) h1-=eym-ey;
}
CopyImageScreen(im+x1-x+(y1-y)*w, s->fon+x1-s->x+(y1-s->y)*s->w,
	w-w1, s->w-w1, w1, h1 ); // ᪮஢  fon
copyByte( s->fon, s->buf, s->w*s->h );
if ( s->shadow==1 )
	magSprImageShadow
	(s->w,s->h,s->sp,s->buf,s->fonColor,s->tab_shadow,s->shadowColor);
else
	magSprImage(s->w,s->h,s->sp,s->buf,s->fonColor);
CopyImageScreen(s->buf+x1-s->x+(y1-s->y)*s->w, im+x1-x+(y1-y)*w,
	s->w-w1, w-w1, w1, h1 ); // ᪮஢  im
return 1;
}
