#include <stdio.h>
#include <alloc.h>
#include <string.h>
#include "magtype.h"
#include "mixer.h"
#include "emm.h"


static word _mixRate=11000, _mixBit=8, _mixLen=0, _mix_ptr=0;
static byte _mixMode=0, _mix_init=0;
static char far * _mixTmp=0;
static char far * _mixBuf=0;

static RawPlay rps[NUM_RAW_PLAY];

///////////////////////////////////////////////////////////////////////////
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	// 樠  㪮

char far * mixInit
	( word rate, byte mode, byte bit_sam, word len_mix )
	//  : !=0 - ଠ, 0 -  ᯥ譮
	// rate -  㪠, mode - =0, 1=८,
	// bit_sam -   롮 8/16,
	// len_mix -  ᨢ 
	// 頥 㪠⥫   
{
_mixTmp=malloc(len_mix);
_mixBuf=malloc(len_mix);
if ( _mixTmp==0 || _mixBuf==0 ) return 0;
_mixRate=rate; _mixMode=mode; _mixBit=bit_sam; _mix_init=1;
memset(&rps,0,sizeof(rps));
memset(_mixTmp,0,len_mix);
memset(_mixBuf,0,len_mix);
_mixLen=len_mix;
return _mixBuf;
}

	//   㪠

void	mixReset
	( void )
{
if ( _mix_init==0 ) return;
mixAllStop();
if ( _mixTmp!=0 ) free(_mixTmp );
if ( _mixBuf!=0 ) free(_mixBuf );
_mix_ptr=_mix_init=0;
}

	// ⠭ 롮  ࠡ⪨  

int	mixSet
	( byte n, int handle, unsigned long beg_off,
	  char far * raw, unsigned long len )
	// : 0 -  㤠筮
	// 	    1 - ᯥ譮
	// n -   ந  NUM_RAW_PLAY
	// handle -  EMM
	// beg_off - ᬥ饭  砫 
	// raw - 㪠⥫  롮
	// len -  롮ન
{
if ( _mix_init==0 ) return 0;
if ( n>=NUM_RAW_PLAY ) return 0;
// ᫨  ந ?? !!
if ( rps[n].is!=0 && rps[n].play!=0 )
	mixStop(n);
if ( raw==0 || len==0 ) return 0;
rps[n].raw=raw; rps[n].len_raw=len; rps[n].off=0; rps[n].is=1;
rps[n].handle=handle; rps[n].beg_raw=beg_off;
rps[n].count=0; rps[n].play=0;
return 1;
}

	//  ந뢠 롮ન

int	mixBeginPlay
	( byte n, word count )
	// : 0 -  㤠筮
	// 	    1 - ᯥ譮
	// n -   ந  NUM_RAW_PLAY
{
byte c;
if ( _mix_init==0 ) return 0;
if ( n>=NUM_RAW_PLAY ) return 0;
//rps[n].off=0;
c=rps[n].count;
rps[n].count+=count; rps[n].play=1;
if ( c==0 )
	mixRaw(n);
return 1;
}

	//  ந 롮ન

word	mixStop
	( byte n )
	// : 0 -  㤠筮
	// 	    1 - ᯥ譮
	// n -   ந  NUM_RAW_PLAY
{
if ( _mix_init==0 ) return 0;
if ( n>=NUM_RAW_PLAY ) return 0;
rps[n].play=0;
rps[n].off=0;
rps[n].count=0;
return 1;
}

	// ⢥ ᬥ訢⥫

static void	_mixer
	( char far * sou, char far * des, word len )
	// sou - 筨 㪠
	// des - ਥ  㪠
	// len - 
{
register word i, tmp;
if ( len==0 || sou==0 || des==0 ) return;
/*for ( i=0; i<len; i++ )
{
	tmp=(byte)*des;
	tmp+=(byte)*sou;
	*des=(byte)(tmp/2);
	des++; sou++;
}*/
// ࠭ ॣ  ⥪
asm	push	ds;
asm	push	es;
// 㫨 䫠 ࠢ DF - 뫪   ᮢ
asm	cld;
// 㧨 筨  DS:SI,  ਥ  ES:DI
asm	les	di,	des;
asm	lds	si,	sou;
// 稪 横
asm	mov	cx,	len;
COS:
// 㧨   sou  AL
asm	lodsb;
//   
asm	shr	al,	1;
// 㧨   des
asm	mov	bl,	es:[di];
//   
asm	shr	bl,	1;
//  
asm	add	al,	bl;
//  १
asm	stosb;
// , ᫨ CX != 0
asm	loop	COS;
// ⠭ ॣ
asm	pop	es;
asm	pop	ds;
}

	//  㪮   

int	mixRaw
	( byte n )
	// : -1 -  㤠筮
	// 	    0>= - ᯥ譮
	// n -   ந  NUM_RAW_PLAY
{
char far * t;
word ptr, len;
long off;
if ( _mix_init==0 ) return -1;
if ( n>=NUM_RAW_PLAY ) return -1;
if ( rps[n].is==0 || rps[n].count==0 || rps[n].play==0 ) return -1;
ptr=0;
while ( 1 )
{
	if ( ptr>=_mixLen ) break;
	if ( rps[n].off>=rps[n].len_raw )
	{
		rps[n].off=0;
		rps[n].count--;
		if ( rps[n].count==0 )
			break;
	}
	if ( (rps[n].len_raw-rps[n].off)<((_mixLen-ptr)*1L) )
		len=rps[n].len_raw-rps[n].off;
	else	len=_mixLen-ptr;
	if ( rps[n].handle!=-1 )
	{
		off=rps[n].off+rps[n].beg_raw;
		t=emm_set(rps[n].handle,off);
	}
	else	t=rps[n].raw+rps[n].off;
	memcpy(_mixTmp+ptr,t,len);
	if ( rps[n].handle!=-1 )
		emm_restore(rps[n].handle);
	rps[n].off+=len;
	ptr+=len;
}
_mixer(_mixTmp,_mixBuf,ptr);
if ( ptr>_mix_ptr )
	_mix_ptr=ptr;
return ptr;
}

	//   㪨

int	mixAllRaw
	( void )
{
byte i;
if ( _mix_init==0 ) return -1;
memset(_mixBuf,0,_mixLen);
memset(_mixTmp,0,_mixLen);
_mix_ptr=0;
for ( i=0; i<NUM_RAW_PLAY; i++ )
	mixRaw(i);
return _mix_ptr;
}

	//  ந

void	mixAllStop
	( void )
{
byte i;
if ( _mix_init==0 ) return;
memset(_mixBuf,0,_mixLen);
for ( i=0; i<NUM_RAW_PLAY; i++ )
	mixStop(i);
_mix_ptr=0;
}

	// 뤠 ⥪  

word	mixLen
	( void )
{
if ( _mix_init==0 ) return 0;
return _mix_ptr;
}

	//  ⥪  

void	mixLenClear
	( void )
{
_mix_ptr=0;
}
