#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <dos.h>
#include <mem.h>
#include "maglib.h"

#define LEN_MAX_BIT	14
#define	LEN_BUF_PACK	2047
#define	LEN_PACK_MAX	(1<<LEN_MAX_BIT)-1
#define REPEAT		1
#define NO_REPEAT	0
#define LIT_NUMBER	1<<(LEN_MAX_BIT-8)

char buf_ch[LEN_BUF_PACK+1];

int	write_zip
	( FILE * f, char * buf, word count, byte state )
{
word p,size;
int rc=-1;
if ( count>=LIT_NUMBER )
{
	size=state & 3;
	size<<=LEN_MAX_BIT; size|=(count & 0x3fff);
	p=(size>>8)&0xff; p|=(size<<8)&0xff00;
	size=2;
}
else
{
	p=(state+2) & 3;
	p<<=LEN_MAX_BIT-8; p|=(count & 0x3f);
	size=1;
}
switch ( state )
{
case REPEAT: {
	rc=fwrite(&p,1,size,f);//᫮  ﭨ
	rc=fwrite(buf,1,1,f);//ᨬ
	break;
	}
case NO_REPEAT: {
	rc=fwrite(&p,1,size,f);//᫮  ﭨ
	rc=fwrite(buf,1,count,f);//
	break;
	}
}
return rc;
}

int	pascal zip_buf
	( FILE *f, long len, char far * buf )
{
char _huge * b;
word count;
byte state;
long ptr;
char ch, prefix;
int rc;
//char * buf_wr=0;
//long offset_len=0, len_zip=0;

b=buf;
state=REPEAT;
count=1;
ch=*b;

//setvbuf(f,buf_wr,_IOFBF,4096);
//fgetpos(f,&offset_len);
//fwrite(&len_zip,1,4,f);

for ( ptr=1L; ptr<len; ptr++ )
{
b++;
prefix=*b;
if ( ch==prefix )
{
    if ( state==REPEAT )
    {
	count++;
	if ( count>=LEN_PACK_MAX )
	{
	   rc=write_zip(f,&ch,count,state);
	   if ( rc==-1 ) return rc;
	   count=1;
	}
    }
    else
    {
	if ( count!=1 )
	{
	rc=write_zip(f,buf_ch,count-1,state);
	if ( rc==-1 ) return rc;
	}
	state=REPEAT;
	count=2;
    }
}
else
{
    if ( state==REPEAT )
    {
	rc=write_zip(f,&ch,count,state);
	if ( rc==-1 ) return rc;
	count=1; state=NO_REPEAT; buf_ch[0]=prefix;
    }
    else
    {
	buf_ch[count++]=prefix;
	if ( count>=LEN_BUF_PACK )
	{
		rc=write_zip(f,buf_ch,count,state);
		if ( rc==-1 ) return rc;
		count=0;
	}
    }
}//else
ch=prefix;
}//for
if ( state==REPEAT )
{
	rc=write_zip(f,&ch,count,state);
	if ( rc==-1 ) return rc;
}
else
{
	rc=write_zip(f,buf_ch,count,state);
	if ( rc==-1 ) return rc;
}
fflush(f);
/*fgetpos(f,&len_zip);
len_zip=len_zip-offset_len-4;
fsetpos(f,&offset_len);
fwrite(&len_zip,1,4,f);
offset_len+=len_zip+4;
fsetpos(f,&offset_len);*/
return 0;
}

int	pascal unzip_buf
	( FILE *f, long len, char far * buf )
{
char _huge * b;
byte state;
long ptr;//, len_zip;
char ch;
word tmp, tmp1;
//char * buf_wr=0;

b=buf;
state=REPEAT;
ptr=0L;

//setvbuf(f,buf_wr,_IOFBF,4096);
//fread(&len_zip,1,4,f);

while ( 1 )
{
fread(&tmp,1,1,f);
state=(tmp>>6)&3;
switch ( state )
{
case 0: { fread(&tmp1,1,1,f); tmp=((tmp<<8)|(tmp1&0xff))&0x3fff;
	fread(b,1,tmp,f);
	break;
}
case 1: { fread(&tmp1,1,1,f); tmp=((tmp<<8)|(tmp1&0xff))&0x3fff;
	fread(&ch,1,1,f); _fmemset(b,ch,tmp);
	break;
}
case 2: { tmp&=0x3f; fread(b,1,tmp,f);
	break;
}
case 3: { tmp&=0x3f; fread(&ch,1,1,f); _fmemset(b,ch,tmp);
	break;
}
}// case
//b=addAddr(b,tmp);
ptr+=tmp; b+=tmp;
if ( ptr>=len ) break;
if ( feof(f)!=0 ) break;
if ( ferror(f)!=0 ) return -1;
} // while

fflush(f);
return 0;
}
