#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <malloc.h>
#include <io.h>
#include <conio.h>
#include <mem.h>
#include <string.h>
#include <string.h>
#include <dir.h>
#include <ctype.h>
#include "magtype.h"
#include "sb.h"
#include "dma.h"
#include "mixer.h"
#include "emm.h"
#include "lib.h"

#define NUM_SOUND 4
#define LEN_BUF 2048

char nameSound[4][15]={
	"s1",
	"s2",
	"s3",
	"s4",
};
int hEmmSound;
long lenSound[NUM_SOUND];
long offSound[NUM_SOUND];

extern DMA_Buf dBuf;
int free_emm, h_emm, frame;


	// ⥭  㪮

int	readSound
	( char * name )
{
Lib * l;
int rc=0, i;
long len, ptrS;
char far * buf;

printf("⥭ 㪮 ...\r");
rc=access(name,0);
if ( rc==-1 )
	{ printf("\n 䠩 - %s\n",name); return -1; }
l=libNew();
if ( l==0 )
	{ printf("\n訡 ᮧ ⥪\n");return -1; }
rc=libOpen(l,name,LEN_BUF);
if ( rc!=OK )
	{ rc=-1; printf("\n  䠩 - %s\n",name);goto Fin; }

len=0L;
for ( i=0; i<NUM_SOUND; i++ )
{
  offSound[i]=lenSound[i]=0L;
  rc=libFind(l,nameSound[i]);
  if ( rc==-1 )	{ rc=0; continue; }
  lenSound[i]=((RecLib*)(l->lf.items[rc]))->len;
  offSound[i]=len;
  len+=lenSound[i];
}
hEmmSound=emm_new((len/(SIZE_FRAME*1L))+1L);
if ( hEmmSound==-1 ) { printf(" \n"); rc=-1; goto Fin; }

for ( i=0; i<NUM_SOUND; i++ )
{
  rc=libSeek(l,nameSound[i]);
  if ( rc==-1 )	{ rc=0; continue; }
  ptrS=0L;
  while ( 1 ) // ⥭ 讣 䠩
  {
    if ( ptrS>=lenSound[i] ) break;
    buf=emm_set(hEmmSound,offSound[i]+ptrS);
    len=lenSound[i]-ptrS;
    if ( len>1000 ) len=1000;
    fread(buf,len,1,l->fr);
    emm_restore(hEmmSound);
    ptrS+=len;
  }
}

Fin:
libClose(l);
libFree(l);
if ( rc==-1 ) { printf("訡 ⥭.\n"); exit(-1); } // emm_delete
else	printf("㪨 ⠭.       \n");
return rc;
}


char far * readRaw
	( char * name, long * len, long off )
{
FILE * f;
char far * buf;
long i;

f=fopen(name,"rb");
if ( f==0 ) return 0;
fseek(f,0L,SEEK_END);
*len=ftell(f);
fseek(f,0L,SEEK_SET);
if ( *len>=0xffff )
	{ fclose(f); return 0; }
buf=emm_set(h_emm,off);
fread(buf,*len,1,f);
fclose(f);
return buf;
}


void	main
	( void )
{
InitSB isb;
int i, i_beg, j;
char far * mix;
char ch;
int mix_len=200;
word len, l;
char far * Raw;

printf("஢ઠ ⥬ EMM, SB, MIXER, LIB\n");
printf("⥭  ந    1,2,3,4 㪮\n");
printf(" ⥪ chsound.lib\n\n");

if ( emm_check()==0 ) printf("EMM \n");
else { printf("EMM \n"); return; }
frame=emm_frame();
printf(" - %X\n",frame);
printf("ᥣ EMS \t- %d, %ldK\n", emm_total(), emm_total()*16l);
printf(" EMS \t- %d, %ldK\n", emm_free(), emm_free()*16l);

if ( readSound("sound.lb")==-1 ) return;

if ( sbEnvData(&isb)==0 )
	printf(" 窨 BLASTER  㦥 !!!\n");
else	printf("BLASTER = A%X, I%d, D%d, T%d\n",
	       isb.port, isb.irq, isb.dma, isb.ver );
if ( sbSetup(isb.port,isb.irq,isb.dma)==0 )
{
	printf("No Sound Blaster\n");
	return;
}

mix=mixInit(22000,0,8,mix_len);
if ( mix==0 )
{
	printf( "訡 \n" );
	sbReset();
	return;
}


  sbRate(22000);

for ( i=0; i<4; i++ )
{
    mixSet(i,hEmmSound,offSound[i],mix,lenSound[i]);
}


i_beg=0;

while ( 1 )
{
	if ( kbhit()!=0 )
	{
		ch=getch();
		switch ( ch )
		{
		case 32: mixAllStop(); break;
		case 27: goto Fin;
		case '1':
			mixStop(0);
			mixBeginPlay(0,1);
			break;
		case '2':
			mixBeginPlay(1,1);
			break;
		case '3':
			mixBeginPlay(2,1);
			break;
		case '4':
			mixBeginPlay(3,1);
			break;
		case 'A':
		case 'a':
			i_beg++;
			if ( i_beg>=NUM_SOUND ) i_beg=0;
			for ( i=0; i<4; i++ )
			{
			    j=i+i_beg; if ( j>=NUM_SOUND ) j-=NUM_SOUND;
			    mixStop(i);
			    mixSet(i,hEmmSound,offSound[j],Raw,lenSound[j]);
			    mixBeginPlay(i,1);
			}
			break;
		}
	}
	l=mixLen();
	if ( l!=0 )
	if ( sbStatePlay()==1 )
	{
		sbPlay(mix,l);
		mixAllRaw();
	}
}


Fin:
sbReset();
mixAllStop();
mixReset();
emm_delete(hEmmSound);
}
